//
//  fairness_utilities.h
//  
//
//  Created by Ivaylo Dobrikov on 21/02/14.
//
//

#ifndef _fairness_utilities_h
#define _fairness_utilities_h

#include "ltlc.h"
#include "tarjan.h"

SP_term_ref create_scc_nodes_list(tarjandata *t, int scc_size);
SP_integer* extract_transids_from_prolog_list(SP_term_ref list, int *rsize);
int check_if_scc_contains_transitions(tarjandata *t, int scc_size, SP_integer *matching_transitions, int msize);
int check_if_scc_contains_transitions1(ltl_formula *f, ltlatom **scc, int scc_size, SP_integer *matching_transitions, int msize);
int enabled_in_each_node(tarjandata *t, int scc_size, SP_integer *matching_transitions, int msize);
int enabled_in_each_node1(ltl_formula *f, ltlatom **scc, int scc_size, SP_integer *matching_transitions, int msize);
int enabled_in_some_node(tarjandata *t, int scc_size, SP_integer *matching_transitions, int msize);
int enabled_in_some_node1(ltl_formula *f, ltlatom **scc, int scc_size, SP_integer *matching_transitions, int msize);
void extract_unfair_atoms(tarjandata *t, int scc_size, SP_integer *matching_transitions, int msize, ltlatom ***runfair, int *rsize);
int must_check_fairness(tarjandata *t);
int is_weak_fair_for_all_operations(tarjandata *t, int scc_size);
int check_if_loop_contains_transitions(ltl_formula *f, ltlatom **loop_atoms, int loop_size, SP_integer *matching_transitions, int msize);
void print_scc_state_ids(SP_term_ref scc_state_ids);
#endif
