#include <iostream>
#include <string>
#include <queue>
using namespace std;

class Prioritize {
public:
     long operator() ( const pair<long,  long>& p1,
                      const pair<long,  long>& p2 ) {
         return p1.second > p2.second;
     }
};


     priority_queue< pair< long,  long >,
        vector <pair< long,  long > >, Prioritize >   prioqueue, copy_prioqueue;

 long mycounter; // a counter
 
extern "C" {

void myheap_reset() {
 cout << "myheap_reset(); \n";
 while (!prioqueue.empty()) {
   prioqueue.pop();
 }
 // can probably be done faster
 // prioqueue = priority_queue< pair< long,  long >, vector <pair< long,  long > >, Prioritize > ();
}

void myheap_copy() {
  copy_prioqueue = prioqueue;
}

void myheap_add_node(long nodeid, long nodeweight){
 //cout << "myheap_add_node: " << nodeid << "," << nodeweight << endl;
 prioqueue.push( pair<long, long>( nodeid, nodeweight) );
}


void mycounter_set(long counterval) {
  mycounter = counterval;
}

long mycounter_dec () {
  return --mycounter;
}


long myheap_size(){
  return prioqueue.size();
}

long myheap_empty(){
  if(prioqueue.empty())
     return 1;
  else
     return 0;
}

long myheap_top_id(){
  return prioqueue.top().first;
}
long myheap_top_weight(){
  return prioqueue.top().second;
}

long myheap_max_weight(){
cout << "### Cannot compute max weight" << endl;
return myheap_top_weight();
}

long myheap_pop(){
 if(prioqueue.empty()) {
   cout << "empty queue" << endl;
   return -1;
 } else {
    long resid = prioqueue.top().first;
    //long resweight = prioqueue.top().second;
    //cout << "myheap_pop: " << resid << ":" << resweight << endl;
    prioqueue.pop();
 	return resid;
 }
}
long myheap_copy_pop(){
 if(copy_prioqueue.empty()) {
   cout << "empty queue" << endl;
   return -1;
 } else {
    long resid = copy_prioqueue.top().first;
    long resweight = copy_prioqueue.top().second;
    cout << "myheap_copy_pop: " << resid << ":" << resweight << endl;
    prioqueue.pop();
 	return resid;
 }
}

long myheap_pop_max(){
	cout << "### Cannot pop from end" << endl;
	return myheap_pop();
}

void myheap_add_node_at_front(long nodeid){
   //cout << "mymultimap_add_node_at_front: " << nodeid  << endl;
    if(prioqueue.empty()) {
	    myheap_add_node(nodeid, 1);
	 } else {
	    myheap_add_node(nodeid, myheap_top_weight() - 1);
	 }
}
void myheap_add_node_at_end(long nodeid){
	   //cout << "mymultimap_add_node_at_front: " << nodeid  << endl;
	   if(prioqueue.empty()) {
	    myheap_add_node(nodeid, 1);
	 } else {
	    myheap_add_node(nodeid, myheap_max_weight() + 1);
	 }
}

}