:- module(test,[test/0, test2/0]).

:- use_module(profiler).
:- use_module(profiler_te).
%:- enable_profiling(test:app/3).
%:- enable_profiling(test:test/0).

:- dynamic waiting_add/3.

:- block waiting_add(?,?,-), waiting_add(?,-,?).

:- enable_profiling(test:waiting_add/3).
waiting_add(S,A,B) :-
    S is A + B.

app([],L,L).
app([H|T],Y,[H|Z]) :- app(T,Y,Z).


nrev( [] ,[] ).
nrev( [H|L] , R) :- nrev(L,RL), app( RL, [H], R ).

gen(Nr,[]) :- Nr<1,!.
gen(Nr,[Nr|T]) :- N1 is Nr-1, gen(N1,T).


test :- gen(1000,L), nrev(L,RL), print(RL),nl.

:- use_module(library(lists)).

%:- enable_profiling(test:pl1/1).
pl1(L) :- maplist(p,L).

p(h).
p(f(X)) :- X<2,!.
p(f(X)) :- p(g(X)).
p(g(X)) :- number(X).

%:- enable_profiling(test:pl2/1).
pl2(L) :- maplist(p2,L).
p2(h).
p2(f(X)) :- p3(X).
p2(g(X)) :- number(X).

p3(X) :- X<2,!.
p3(X) :- p(g(X)).

gen2(Nr,[]) :- Nr<1,!.
gen2(Nr,[f(Nr)|T]) :- N1 is Nr-1, gen2(N1,T).

test2 :- gen2(100000,L), pl1(L), pl2(L), profiler:pen.
