#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "../../../include/zmq.h"
#include "../../../include/czmq.h"

#include "wid.h"


static void init_socket(zctx_t *ctx, char *masteraddr, int port);
static void close_socket(zctx_t *ctx);



static void *id_req = NULL;

struct Preferences *get_id(void) {
    zstr_send(id_req, "worker");

    zmsg_t *msg = zmsg_recv(id_req);

    int msg_size = zmsg_size(msg);
    assert(msg_size == 2);
    zframe_t *idframe = zmsg_pop(msg);
    zframe_t *modelframe = zmsg_pop(msg);

    struct Preferences *p = malloc(sizeof(struct Preferences));

    char *id = zframe_strdup(idframe);
    assert(id);
    p->id = id;
    char *model = zframe_strdup(modelframe);
    assert(model);
    p->model = model;

    zframe_destroy(&idframe);
    zframe_destroy(&modelframe);

    zmsg_destroy(&msg);

    return p;
}


void init_id(zctx_t *ctx, char *masteraddr, int port) {
    assert(id_req == NULL);
    id_req = zsocket_new(ctx, ZMQ_REQ);
    //zsocket_connect(id_req,"tcp://%s:%i", masteraddr, port + 5);
    zsocket_connect(id_req, "ipc:///tmp/zmq-proxy-%i", port + 5);
}

void teardown_id(zctx_t *ctx) {
    zsocket_destroy(ctx, id_req);
    id_req = NULL;
}
