:- module(synthesis_tests,[run_tests/0,run_tests/1]).

:- use_module(library(plunit)).
:- use_module(probsrc(solver_interface),[solve_predicate/3]). 
:- use_module(synthesis(b_synthesis)).
:- use_module(synthesis(library_setup)).

:- begin_tests(location_vars_to_program).

test(lVar2Prog_1) :- 
    b_synthesis:location_vars_to_program(([card-set(integer),constant-set(integer),constant-integer,greater],[]),guard,
            [b(identifier(var),set(integer),[])],
            [b(identifier(li68),integer,[synthesis(card1,input),synthesis(type,set(integer))]),b(identifier(li74),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo69),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo70),integer,[synthesis(constant71,output),synthesis(type,set(integer))]),b(identifier(lo72),integer,[synthesis(constant73,output),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(greater1,output),synthesis(type,boolean)])],
            4,1,
            solution([binding(constant71,[],{}),binding(constant73,int(1),'1'),binding(l0set,int(0),'0'),binding(li68,int(0),'0'),binding(li74,int(3),'3'),binding(li75,int(2),'2'),binding(lo0boolean_false,int(4),'4'),binding(lo0boolean_true,int(4),'4'),binding(lo69,int(3),'3'),binding(lo70,int(1),'1'),binding(lo72,int(2),'2'),binding(lo76,int(4),'4'),binding(o72,int(-10),'-10')]),
            [b(identifier(lo76),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo69),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo72),integer,[synthesis(constant73,output),synthesis(type,integer)])],
            ProgramAST) , 
    ProgramAST = b(greater(b(card(b(identifier(var),set(integer),[])),integer,[]),b(integer(1),integer,[])),boolean,[]).

test(lVar2Prog_2) :- 
    b_synthesis:location_vars_to_program(([greater,equal-integer,constant-integer],[]),guard,
            [b(identifier(var),integer,[])],
            [b(identifier(li86),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li87),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li89),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li90),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo88),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo91),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo92),integer,[synthesis(constant93,output),synthesis(type,integer)])],
            3,1,
            solution([binding(constant93,int(0),'0'),binding(l00,int(0),'0'),binding(l01,int(0),'0'),binding(li86,int(0),'0'),binding(li87,int(1),'1'),binding(li89,int(0),'0'),binding(li90,int(0),'0'),binding(lo0boolean_false,int(3),'3'),binding(lo0boolean_true,int(3),'3'),binding(lo88,int(3),'3'),binding(lo91,int(2),'2'),binding(lo92,int(1),'1'),binding(o92,int(-10),'-10')]),
            [b(identifier(lo88),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo92),integer,[synthesis(constant93,output),synthesis(type,integer)])],
            ProgramAST) , 
    ProgramAST = b(greater(b(identifier(var),integer,[]),b(integer(0),integer,[])),boolean,[]).

test(lVar2Prog_3) :- 
    b_synthesis:location_vars_to_program(([greater,equal-integer,constant-integer],[]),invariant,
            [b(identifier(var),integer,[])],
            [b(identifier(li102),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li103),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li105),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li106),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo104),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo107),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo108),integer,[synthesis(constant109,output),synthesis(type,integer)])],
            3,1,
            solution([binding(constant109,int(-1),'-1'),binding('l0-1',int(0),'0'),binding('l0-2',int(0),'0'),binding(l00,int(0),'0'),binding(l01,int(0),'0'),binding(l02,int(0),'0'),binding(l03,int(0),'0'),binding(l04,int(0),'0'),binding(l05,int(0),'0'),binding(li102,int(0),'0'),binding(li103,int(1),'1'),binding(li105,int(0),'0'),binding(li106,int(0),'0'),binding(lo0boolean_false,int(3),'3'),binding(lo0boolean_true,int(3),'3'),binding(lo104,int(3),'3'),binding(lo107,int(2),'2'),binding(lo108,int(1),'1'),binding(o108,int(-10),'-10')]),
            [b(identifier(lo104),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo108),integer,[synthesis(constant109,output),synthesis(type,integer)])],
            ProgramAST) , 
    ProgramAST = b(greater(b(identifier(var),integer,[]),b(integer(-1),integer,[])),boolean,[]).

test(lVar2Prog_4) :- 
    b_synthesis:location_vars_to_program(([greater,equal-integer,constant-integer],[add,minus]),guard,
        [b(identifier(var1),integer,[]),b(identifier(var2),integer,[])],
        [b(identifier(li448),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li449),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li451),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li452),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li456),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li457),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(li459),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(li460),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo450),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo453),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo454),integer,[synthesis(constant455,output),synthesis(type,integer)]),b(identifier(lo458),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(lo461),integer,[synthesis(minus1,output),synthesis(type,integer)])],
        6,2,
        solution([binding(constant455,int(1),'1'),binding('l0-1',int(0),'0'),binding(l00,int(0),'0'),binding(l01,int(0),'0'),binding(l02,int(0),'0'),binding(l10,int(1),'1'),binding(l11,int(1),'1'),binding(l12,int(1),'1'),binding(li448,int(3),'3'),binding(li449,int(4),'4'),binding(li451,int(0),'0'),binding(li452,int(0),'0'),binding(li456,int(1),'1'),binding(li457,int(0),'0'),binding(li459,int(0),'0'),binding(li460,int(0),'0'),binding(lo0boolean_false,int(6),'6'),binding(lo0boolean_true,int(6),'6'),binding(lo450,int(6),'6'),binding(lo453,int(5),'5'),binding(lo454,int(4),'4'),binding(lo458,int(3),'3'),binding(lo461,int(2),'2'),binding(o454,int(-10),'-10')]),[b(identifier(lo450),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo458),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(lo454),integer,[synthesis(constant455,output),synthesis(type,integer)])],
        ProgramAST) , 
    ProgramAST = b(greater(b(add(b(identifier(var2),integer,[]),b(identifier(var1),integer,[])),integer,[]),b(integer(1),integer,[])),boolean,[]).

:- end_tests(location_vars_to_program).

:- begin_tests(synthesis).

test(synthesis_1,[nondet]) :- 
    library_setup(guard,1,[b(value(avl_set(node((int(0),int(1)),true,1,empty,node((int(1),int(2)),true,0,empty,empty)))),set(couple(integer,integer)),[synthesis(machinevar,ee)])],Library) , 
    b_synthesis:synthesis_from_examples(Library,1,[b(identifier(ee),set(couple(integer,integer)),[nodeid(pos(15,1,5,2,5,3)),loc(local,test_seq_mch,abstract_variables)])],[b(subset(b(identifier(sub),set(couple(integer,integer)),[nodeid(pos(33,1,9,29,9,31)),readonly]),b(identifier(ee),set(couple(integer,integer)),[nodeid(pos(34,1,9,36,9,37)),loc(local,test_seq_mch,abstract_variables)])),pred,[nodeid(pos(32,1,9,29,9,37))]),b(disjunct(b(equal(b(card(b(identifier(sub),set(couple(integer,integer)),[nodeid(pos(38,1,9,48,9,50)),readonly])),integer,[contains_wd_condition,nodeid(pos(37,1,9,43,9,51))]),b(integer(1),integer,[nodeid(pos(39,1,9,55,9,55))])),pred,[contains_wd_condition,nodeid(pos(36,1,9,43,9,55))]),b(equal(b(card(b(identifier(sub),set(couple(integer,integer)),[nodeid(pos(42,1,9,65,9,67)),readonly])),integer,[contains_wd_condition,nodeid(pos(41,1,9,60,9,68))]),b(integer(0),integer,[nodeid(pos(43,1,9,72,9,72))])),pred,[contains_wd_condition,nodeid(pos(40,1,9,60,9,72))])),pred,[contains_wd_condition,nodeid(pos(35,1,9,43,9,72))])],guard,[[b(value(avl_set(node((int(0),int(1)),true,1,empty,node((int(1),int(2)),true,0,empty,empty)))),set(couple(integer,integer)),[synthesis(machinevar,ee)])],[b(value(avl_set(node((int(0),int(1)),true,1,empty,node((int(1),int(2)),true,0,empty,empty)))),set(couple(integer,integer)),[synthesis(machinevar,ee)])],[b(value(avl_set(node((int(0),int(1)),true,1,empty,node((int(1),int(2)),true,0,empty,empty)))),set(couple(integer,integer)),[synthesis(machinevar,ee)])]],[[b(value(avl_set(node((int(1),int(2)),true,0,empty,empty))),set(couple(integer,integer)),[synthesis(machinevar,ee)])]],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(o5),integer,[synthesis(constant6,output)]),b(interval(b(integer(-10),integer,[]),b(integer(11),integer,[])),set(integer),[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(interval(b(integer(0),integer,[]),b(integer(4),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(4),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(4),integer,[])),set(integer),[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(interval(b(integer(1),integer,[]),b(integer(4),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(interval(b(integer(1),integer,[]),b(integer(4),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(interval(b(integer(1),integer,[]),b(integer(4),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(interval(b(integer(1),integer,[]),b(integer(4),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(less(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[]),b(less(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[])),pred,[]),b(exists([b(identifier(o9),boolean,[synthesis(greater1,output)]),b(identifier(o5),integer,[synthesis(constant6,output)]),b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)]),b(identifier(o2),integer,[synthesis(card1,output)]),b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(4),integer,[])),pred,[]),b(equal(b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equal(b(card(b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)])),integer,[]),b(identifier(o2),integer,[synthesis(card1,output)])),pred,[]),b(equal(b(identifier(constant4),set(couple(integer,integer)),[]),b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)])),pred,[])),pred,[]),b(equal(b(identifier(constant6),integer,[]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(greater(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i8),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o9),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i8),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o9),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[]),b(equal(b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)]),b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[]),b(equal(b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)]),b(value(avl_set(node((int(0),int(1)),true,1,empty,node((int(1),int(2)),true,0,empty,empty)))),set(couple(integer,integer)),[synthesis(input(0)),synthesis(machinevar,ee)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i8),integer,[synthesis(greater1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(o2),integer,[synthesis(card1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(identifier(o2),integer,[synthesis(card1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o2),integer,[synthesis(card1,output)]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[]),b(equal(b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)]),b(value(avl_set(node((int(0),int(1)),true,1,empty,node((int(1),int(2)),true,0,empty,empty)))),set(couple(integer,integer)),[synthesis(input(0)),synthesis(machinevar,ee)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o9),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(member(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant4,constant6,i1,i7,i8,l0set,li1,li7,li8,lo0boolean_true,lo2,lo3,lo5,lo9,o2,o3,o5,o9])])),pred,[]),b(exists([b(identifier(o9),boolean,[synthesis(greater1,output)]),b(identifier(o5),integer,[synthesis(constant6,output)]),b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)]),b(identifier(o2),integer,[synthesis(card1,output)]),b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(4),integer,[])),pred,[]),b(equal(b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equal(b(card(b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)])),integer,[]),b(identifier(o2),integer,[synthesis(card1,output)])),pred,[]),b(equal(b(identifier(constant4),set(couple(integer,integer)),[]),b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)])),pred,[])),pred,[]),b(equal(b(identifier(constant6),integer,[]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(greater(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i8),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o9),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i8),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o9),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[]),b(equal(b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)]),b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[]),b(equal(b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)]),b(value(avl_set(node((int(0),int(1)),true,1,empty,node((int(1),int(2)),true,0,empty,empty)))),set(couple(integer,integer)),[synthesis(input(0)),synthesis(machinevar,ee)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i8),integer,[synthesis(greater1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(o2),integer,[synthesis(card1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(identifier(o2),integer,[synthesis(card1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o2),integer,[synthesis(card1,output)]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[]),b(equal(b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)]),b(value(avl_set(node((int(0),int(1)),true,1,empty,node((int(1),int(2)),true,0,empty,empty)))),set(couple(integer,integer)),[synthesis(input(0)),synthesis(machinevar,ee)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o9),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(member(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant4,constant6,i1,i7,i8,l0set,li1,li7,li8,lo0boolean_true,lo2,lo3,lo5,lo9,o2,o3,o5,o9])])),pred,[]),b(exists([b(identifier(o9),boolean,[synthesis(greater1,output)]),b(identifier(o5),integer,[synthesis(constant6,output)]),b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)]),b(identifier(o2),integer,[synthesis(card1,output)]),b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(4),integer,[])),pred,[]),b(equal(b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equal(b(card(b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)])),integer,[]),b(identifier(o2),integer,[synthesis(card1,output)])),pred,[]),b(equal(b(identifier(constant4),set(couple(integer,integer)),[]),b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)])),pred,[])),pred,[]),b(equal(b(identifier(constant6),integer,[]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(greater(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i8),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o9),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i8),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o9),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[]),b(equal(b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)]),b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[]),b(equal(b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)]),b(value(avl_set(node((int(0),int(1)),true,1,empty,node((int(1),int(2)),true,0,empty,empty)))),set(couple(integer,integer)),[synthesis(input(0)),synthesis(machinevar,ee)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i8),integer,[synthesis(greater1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(o2),integer,[synthesis(card1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(identifier(o2),integer,[synthesis(card1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o2),integer,[synthesis(card1,output)]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[]),b(equal(b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)]),b(value(avl_set(node((int(0),int(1)),true,1,empty,node((int(1),int(2)),true,0,empty,empty)))),set(couple(integer,integer)),[synthesis(input(0)),synthesis(machinevar,ee)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o9),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(member(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant4,constant6,i1,i7,i8,l0set,li1,li7,li8,lo0boolean_true,lo2,lo3,lo5,lo9,o2,o3,o5,o9])])),pred,[]),b(exists([b(identifier(o9),boolean,[synthesis(greater1,output)]),b(identifier(o5),integer,[synthesis(constant6,output)]),b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)]),b(identifier(o2),integer,[synthesis(card1,output)]),b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(4),integer,[])),pred,[]),b(equal(b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equal(b(card(b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)])),integer,[]),b(identifier(o2),integer,[synthesis(card1,output)])),pred,[]),b(equal(b(identifier(constant4),set(couple(integer,integer)),[]),b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)])),pred,[])),pred,[]),b(equal(b(identifier(constant6),integer,[]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(greater(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i8),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o9),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i8),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o9),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[]),b(equal(b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)]),b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[]),b(equal(b(identifier(i1),set(couple(integer,integer)),[synthesis(card1,input)]),b(value(avl_set(node((int(1),int(2)),true,0,empty,empty))),set(couple(integer,integer)),[synthesis(input(0)),synthesis(machinevar,ee)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(i8),integer,[synthesis(greater1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(o2),integer,[synthesis(card1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(identifier(o2),integer,[synthesis(card1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o2),integer,[synthesis(card1,output)]),b(identifier(o5),integer,[synthesis(constant6,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[]),b(equal(b(identifier(o3),set(couple(integer,integer)),[synthesis(constant4,output)]),b(value(avl_set(node((int(1),int(2)),true,0,empty,empty))),set(couple(integer,integer)),[synthesis(input(0)),synthesis(machinevar,ee)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(not_equal(b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o9),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(l0set),integer,[synthesis(input(0)),synthesis(machinevar,ee),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(member(b(identifier(i7),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i8),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant4,constant6,i1,i7,i8,l0set,li1,li7,li8,lo0boolean_false,lo2,lo3,lo5,lo9,o2,o3,o5,o9])])),pred,[]),[b(identifier(li1),integer,[synthesis(card1,input),synthesis(type,set(couple(integer,integer)))]),b(identifier(li7),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li8),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo2),integer,[synthesis(card1,output),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(constant4,output),synthesis(type,set(couple(integer,integer)))]),b(identifier(lo5),integer,[synthesis(constant6,output),synthesis(type,integer)]),b(identifier(lo9),integer,[synthesis(greater1,output),synthesis(type,boolean)])],4,1,solution([binding(constant4,[],{}),binding(constant6,int(1),'1'),binding(l0set,int(0),'0'),binding(li1,int(0),'0'),binding(li7,int(3),'3'),binding(li8,int(2),'2'),binding(lo0boolean_false,int(4),'4'),binding(lo0boolean_true,int(4),'4'),binding(lo2,int(3),'3'),binding(lo3,int(1),'1'),binding(lo5,int(2),'2'),binding(lo9,int(4),'4'),binding(o5,int(-10),'-10')]),Synthesized) , 
    solve_predicate(b(equivalence(Synthesized,b(conjunct(b(conjunct(b(greater(b(card(b(identifier(ee),set(couple(integer,integer)),[])),set(couple(integer,integer)),[]),b(integer(1),integer,[])),boolean,[]),b(subset(b(identifier(sub),set(couple(integer,integer)),[nodeid(pos(33,1,9,29,9,31)),readonly]),b(identifier(ee),set(couple(integer,integer)),[nodeid(pos(34,1,9,36,9,37)),loc(local,test_seq_mch,abstract_variables)])),pred,[nodeid(pos(32,1,9,29,9,37))])),pred,[]),b(disjunct(b(equal(b(card(b(identifier(sub),set(couple(integer,integer)),[nodeid(pos(38,1,9,48,9,50)),readonly])),integer,[contains_wd_condition,nodeid(pos(37,1,9,43,9,51))]),b(integer(1),integer,[nodeid(pos(39,1,9,55,9,55))])),pred,[contains_wd_condition,nodeid(pos(36,1,9,43,9,55))]),b(equal(b(card(b(identifier(sub),set(couple(integer,integer)),[nodeid(pos(42,1,9,65,9,67)),readonly])),integer,[contains_wd_condition,nodeid(pos(41,1,9,60,9,68))]),b(integer(0),integer,[nodeid(pos(43,1,9,72,9,72))])),pred,[contains_wd_condition,nodeid(pos(40,1,9,60,9,72))])),pred,[contains_wd_condition,nodeid(pos(35,1,9,43,9,72))])),pred,[contains_wd_condition])),pred,[]),_,_).

test(synthesis_2,[nondet]) :- 
    library_setup(guard,1,[b(integer(-1),integer,[synthesis(machinevar,c)]),b(integer(3),integer,[synthesis(machinevar,d)])],Library) , 
    b_synthesis:synthesis_from_examples(Library,1,[b(identifier(c),integer,[nodeid(pos(18,1,4,30,4,30)),loc(local,lift,abstract_variables)]),b(identifier(d),integer,[nodeid(pos(19,1,4,34,4,34)),loc(local,lift,abstract_variables)])],any,guard,[[b(integer(-1),integer,[synthesis(machinevar,c)]),b(integer(3),integer,[synthesis(machinevar,d)])],[b(integer(4),integer,[synthesis(machinevar,c)]),b(integer(-2),integer,[synthesis(machinevar,d)])],[b(integer(0),integer,[synthesis(machinevar,c)]),b(integer(3),integer,[synthesis(machinevar,d)])]],[[b(integer(0),integer,[synthesis(machinevar,c)]),b(integer(1),integer,[synthesis(machinevar,d)])]],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(o77),integer,[synthesis(constant78,output)]),b(interval(b(integer(-10),integer,[]),b(integer(11),integer,[])),set(integer),[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(6),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(6),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(6),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(6),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(6),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(6),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(6),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(6),integer,[])),set(integer),[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(interval(b(integer(2),integer,[]),b(integer(6),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(interval(b(integer(2),integer,[]),b(integer(6),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(interval(b(integer(2),integer,[]),b(integer(6),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(interval(b(integer(2),integer,[]),b(integer(6),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)]),b(interval(b(integer(2),integer,[]),b(integer(6),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(less(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[]),b(less(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(conjunct(b(less(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(less(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(less(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(less(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(less(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(less(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(exists([b(identifier(o84),integer,[synthesis(minus1,output)]),b(identifier(o81),integer,[synthesis(add1,output)]),b(identifier(o77),integer,[synthesis(constant78,output)]),b(identifier(o76),boolean,[synthesis(equal1,output)]),b(identifier(o73),boolean,[synthesis(greater1,output)]),b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i71),integer,[synthesis(greater1,left_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(6),integer,[])),pred,[]),b(conjunct(b(equal(b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)]),b(integer(1),integer,[])),pred,[]),b(equal(b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o76),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o76),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant78),integer,[]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[]),b(equal(b(add(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),integer,[]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[]),b(equal(b(minus(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),integer,[]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i74),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i74),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(identifier(o76),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o76),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o81),integer,[synthesis(add1,output)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o81),integer,[synthesis(add1,output)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o81),integer,[synthesis(add1,output)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o84),integer,[synthesis(minus1,output)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o84),integer,[synthesis(minus1,output)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,c)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant78,i71,i72,i74,i75,i79,i80,i82,i83,'l0-1',l13,li71,li72,li74,li75,li79,li80,li82,li83,lo0boolean_true,lo73,lo76,lo77,lo81,lo84,o73,o76,o77,o81,o84])])),pred,[]),b(exists([b(identifier(o84),integer,[synthesis(minus1,output)]),b(identifier(o81),integer,[synthesis(add1,output)]),b(identifier(o77),integer,[synthesis(constant78,output)]),b(identifier(o76),boolean,[synthesis(equal1,output)]),b(identifier(o73),boolean,[synthesis(greater1,output)]),b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i71),integer,[synthesis(greater1,left_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(6),integer,[])),pred,[]),b(conjunct(b(equal(b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)]),b(integer(1),integer,[])),pred,[]),b(equal(b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o76),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o76),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant78),integer,[]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[]),b(equal(b(add(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),integer,[]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[]),b(equal(b(minus(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),integer,[]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i74),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(integer(-2),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i74),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(integer(-2),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(integer(-2),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(integer(-2),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(integer(-2),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(integer(-2),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(integer(-2),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(integer(-2),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(identifier(o76),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o76),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(integer(-2),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o81),integer,[synthesis(add1,output)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o81),integer,[synthesis(add1,output)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o81),integer,[synthesis(add1,output)]),b(integer(-2),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o84),integer,[synthesis(minus1,output)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o84),integer,[synthesis(minus1,output)]),b(integer(-2),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,c)]),b(integer(-2),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier('l1-2'),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant78,i71,i72,i74,i75,i79,i80,i82,i83,l04,'l1-2',li71,li72,li74,li75,li79,li80,li82,li83,lo0boolean_true,lo73,lo76,lo77,lo81,lo84,o73,o76,o77,o81,o84])])),pred,[]),b(exists([b(identifier(o84),integer,[synthesis(minus1,output)]),b(identifier(o81),integer,[synthesis(add1,output)]),b(identifier(o77),integer,[synthesis(constant78,output)]),b(identifier(o76),boolean,[synthesis(equal1,output)]),b(identifier(o73),boolean,[synthesis(greater1,output)]),b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i71),integer,[synthesis(greater1,left_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(6),integer,[])),pred,[]),b(conjunct(b(equal(b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)]),b(integer(1),integer,[])),pred,[]),b(equal(b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o76),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o76),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant78),integer,[]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[]),b(equal(b(add(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),integer,[]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[]),b(equal(b(minus(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),integer,[]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i74),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i74),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(identifier(o76),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o76),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o81),integer,[synthesis(add1,output)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o81),integer,[synthesis(add1,output)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o81),integer,[synthesis(add1,output)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o84),integer,[synthesis(minus1,output)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o84),integer,[synthesis(minus1,output)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)]),b(integer(3),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(l13),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant78,i71,i72,i74,i75,i79,i80,i82,i83,l00,l13,li71,li72,li74,li75,li79,li80,li82,li83,lo0boolean_true,lo73,lo76,lo77,lo81,lo84,o73,o76,o77,o81,o84])])),pred,[]),b(exists([b(identifier(o84),integer,[synthesis(minus1,output)]),b(identifier(o81),integer,[synthesis(add1,output)]),b(identifier(o77),integer,[synthesis(constant78,output)]),b(identifier(o76),boolean,[synthesis(equal1,output)]),b(identifier(o73),boolean,[synthesis(greater1,output)]),b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i71),integer,[synthesis(greater1,left_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(6),integer,[])),pred,[]),b(conjunct(b(equal(b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)]),b(integer(1),integer,[])),pred,[]),b(equal(b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o76),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o76),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant78),integer,[]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[]),b(equal(b(add(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),integer,[]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[]),b(equal(b(minus(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),integer,[]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i72),integer,[synthesis(greater1,right_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i74),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(integer(1),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i74),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(integer(1),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i75),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(integer(1),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i79),integer,[synthesis(add1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(integer(1),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i80),integer,[synthesis(add1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(integer(1),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(i82),integer,[synthesis(minus1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(integer(1),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(i83),integer,[synthesis(minus1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(integer(1),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(o77),integer,[synthesis(constant78,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(integer(1),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(identifier(o76),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o73),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o76),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(identifier(o81),integer,[synthesis(add1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o77),integer,[synthesis(constant78,output)]),b(integer(1),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o81),integer,[synthesis(add1,output)]),b(identifier(o84),integer,[synthesis(minus1,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o81),integer,[synthesis(add1,output)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o81),integer,[synthesis(add1,output)]),b(integer(1),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o84),integer,[synthesis(minus1,output)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o84),integer,[synthesis(minus1,output)]),b(integer(1),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)])),pred,[]),b(equal(b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)]),b(integer(1),integer,[synthesis(input(1)),synthesis(machinevar,d)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(l11),integer,[synthesis(input(1)),synthesis(machinevar,d),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i71),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i72),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i74),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i75),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i79),integer,[synthesis(add1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i80),integer,[synthesis(add1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i82),integer,[synthesis(minus1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i83),integer,[synthesis(minus1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant78,i71,i72,i74,i75,i79,i80,i82,i83,l00,l11,li71,li72,li74,li75,li79,li80,li82,li83,lo0boolean_false,lo73,lo76,lo77,lo81,lo84,o73,o76,o77,o81,o84])])),pred,[]),[b(identifier(li71),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li72),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li74),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li75),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li79),integer,[synthesis(add1,left_input),synthesis(type,integer)]),b(identifier(li80),integer,[synthesis(add1,right_input),synthesis(type,integer)]),b(identifier(li82),integer,[synthesis(minus1,left_input),synthesis(type,integer)]),b(identifier(li83),integer,[synthesis(minus1,right_input),synthesis(type,integer)]),b(identifier(lo73),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo76),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo77),integer,[synthesis(constant78,output),synthesis(type,integer)]),b(identifier(lo81),integer,[synthesis(add1,output),synthesis(type,integer)]),b(identifier(lo84),integer,[synthesis(minus1,output),synthesis(type,integer)])],6,2,solution([binding(constant78,int(1),'1'),binding('l0-1',int(0),'0'),binding(l00,int(0),'0'),binding(l04,int(0),'0'),binding('l1-2',int(1),'1'),binding(l11,int(1),'1'),binding(l13,int(1),'1'),binding(li71,int(3),'3'),binding(li72,int(4),'4'),binding(li74,int(0),'0'),binding(li75,int(0),'0'),binding(li79,int(1),'1'),binding(li80,int(0),'0'),binding(li82,int(0),'0'),binding(li83,int(0),'0'),binding(lo0boolean_false,int(6),'6'),binding(lo0boolean_true,int(6),'6'),binding(lo73,int(6),'6'),binding(lo76,int(5),'5'),binding(lo77,int(4),'4'),binding(lo81,int(3),'3'),binding(lo84,int(2),'2'),binding(o77,int(-10),'-10')]),Synthesized) , 
    solve_predicate(b(equivalence(Synthesized,b(greater(b(add(b(identifier(c),integer,[]),b(identifier(d),integer,[])),integer,[]),b(integer(1),integer,[])),pred,[])),pred,[]),_,_).

test(synthesis_3,[nondet]) :- 
    library_setup(guard,1,[b(integer(1),integer,[synthesis(machinevar,c)])],Library) , 
    b_synthesis:synthesis_from_examples(Library,1,[b(identifier(c),integer,[nodeid(pos(8,1,4,2,4,2)),loc(local,lift,abstract_variables)])],any,guard,[[b(integer(1),integer,[synthesis(machinevar,c)])],[b(integer(2),integer,[synthesis(machinevar,c)])]],[[b(integer(0),integer,[synthesis(machinevar,c)])]],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(o7),integer,[synthesis(constant8,output)]),b(interval(b(integer(-10),integer,[]),b(integer(11),integer,[])),set(integer),[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(member(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(interval(b(integer(1),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(interval(b(integer(1),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)]),b(interval(b(integer(1),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(not_equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(less(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[]),b(less(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(conjunct(b(less(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(less(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(exists([b(identifier(o7),integer,[synthesis(constant8,output)]),b(identifier(o6),boolean,[synthesis(equal1,output)]),b(identifier(o3),boolean,[synthesis(greater1,output)]),b(identifier(i5),integer,[synthesis(equal1,right_input)]),b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(identifier(i1),integer,[synthesis(greater1,left_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(3),integer,[])),pred,[]),b(equal(b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i2),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o3),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i2),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o3),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o6),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o6),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant8),integer,[]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i2),integer,[synthesis(greater1,right_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i4),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(integer(1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(identifier(i4),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(integer(1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(integer(1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i5),integer,[synthesis(equal1,right_input)]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i5),integer,[synthesis(equal1,right_input)]),b(integer(1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o3),boolean,[synthesis(greater1,output)]),b(identifier(o6),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o3),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o6),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o7),integer,[synthesis(constant8,output)]),b(integer(1),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i5),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant8,i1,i2,i4,i5,l01,li1,li2,li4,li5,lo0boolean_true,lo3,lo6,lo7,o3,o6,o7])])),pred,[]),b(exists([b(identifier(o7),integer,[synthesis(constant8,output)]),b(identifier(o6),boolean,[synthesis(equal1,output)]),b(identifier(o3),boolean,[synthesis(greater1,output)]),b(identifier(i5),integer,[synthesis(equal1,right_input)]),b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(identifier(i1),integer,[synthesis(greater1,left_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(3),integer,[])),pred,[]),b(equal(b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i2),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o3),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i2),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o3),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o6),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o6),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant8),integer,[]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i2),integer,[synthesis(greater1,right_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i4),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(integer(2),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(identifier(i4),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(integer(2),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(integer(2),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i5),integer,[synthesis(equal1,right_input)]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i5),integer,[synthesis(equal1,right_input)]),b(integer(2),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o3),boolean,[synthesis(greater1,output)]),b(identifier(o6),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o3),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o6),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o7),integer,[synthesis(constant8,output)]),b(integer(2),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i5),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant8,i1,i2,i4,i5,l02,li1,li2,li4,li5,lo0boolean_true,lo3,lo6,lo7,o3,o6,o7])])),pred,[]),b(exists([b(identifier(o7),integer,[synthesis(constant8,output)]),b(identifier(o6),boolean,[synthesis(equal1,output)]),b(identifier(o3),boolean,[synthesis(greater1,output)]),b(identifier(i5),integer,[synthesis(equal1,right_input)]),b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(identifier(i1),integer,[synthesis(greater1,left_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(3),integer,[])),pred,[]),b(equal(b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i2),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o3),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i2),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o3),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o6),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o6),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant8),integer,[]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i2),integer,[synthesis(greater1,right_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i4),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(identifier(i4),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(i5),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i5),integer,[synthesis(equal1,right_input)]),b(identifier(o7),integer,[synthesis(constant8,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i5),integer,[synthesis(equal1,right_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o3),boolean,[synthesis(greater1,output)]),b(identifier(o6),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o3),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o6),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o7),integer,[synthesis(constant8,output)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,c)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,c),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i1),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i2),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i4),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i5),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant8,i1,i2,i4,i5,l00,li1,li2,li4,li5,lo0boolean_false,lo3,lo6,lo7,o3,o6,o7])])),pred,[]),[b(identifier(li1),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(li2),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li4),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li5),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo3),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo6),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo7),integer,[synthesis(constant8,output),synthesis(type,integer)])],3,1,solution([binding(constant8,int(0),'0'),binding(l00,int(0),'0'),binding(l01,int(0),'0'),binding(l02,int(0),'0'),binding(li1,int(0),'0'),binding(li2,int(1),'1'),binding(li4,int(0),'0'),binding(li5,int(0),'0'),binding(lo0boolean_false,int(3),'3'),binding(lo0boolean_true,int(3),'3'),binding(lo3,int(3),'3'),binding(lo6,int(2),'2'),binding(lo7,int(1),'1'),binding(o7,int(-10),'-10')]),Synthesized) , 
    solve_predicate(b(equivalence(Synthesized,b(greater(b(identifier(c),integer,[]),b(integer(0),integer,[])),pred,[])),pred,[]),_,_).

test(synthesis_4,[nondet]) :- 
    library_setup(invariant,1,[b(integer(0),integer,[synthesis(machinevar,soda)])],Library) , 
    b_synthesis:synthesis_from_examples(Library,1,[b(identifier(soda),integer,[nodeid(pos(10,1,4,2,4,5)),loc(local,simple_vending_machine,abstract_variables)])],[b(greater_equal(b(identifier(coins),integer,[nodeid(pos(13,1,4,13,4,17)),loc(local,simple_vending_machine,abstract_variables)]),b(integer(0),integer,[nodeid(pos(14,1,4,22,4,22))])),pred,[section(invariant),nodeid(pos(12,1,4,13,4,22))])],invariant,[[b(integer(0),integer,[synthesis(machinevar,soda)])],[b(integer(1),integer,[synthesis(machinevar,soda)])],[b(integer(2),integer,[synthesis(machinevar,soda)])],[b(integer(3),integer,[synthesis(machinevar,soda)])],[b(integer(4),integer,[synthesis(machinevar,soda)])],[b(integer(5),integer,[synthesis(machinevar,soda)])]],[[b(integer(-1),integer,[synthesis(machinevar,soda)])],[b(integer(-1),integer,[synthesis(machinevar,soda)])],[b(integer(-2),integer,[synthesis(machinevar,soda)])]],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(o15),integer,[synthesis(constant16,output)]),b(interval(b(integer(-10),integer,[]),b(integer(11),integer,[])),set(integer),[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(interval(b(integer(0),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(member(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(interval(b(integer(1),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(interval(b(integer(1),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(interval(b(integer(1),integer,[]),b(integer(3),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(less(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[]),b(less(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(conjunct(b(less(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(less(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(exists([b(identifier(o15),integer,[synthesis(constant16,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)]),b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(3),integer,[])),pred,[]),b(equal(b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant16),integer,[]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o15),integer,[synthesis(constant16,output)]),b(integer(0),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(l00),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant16,i10,i12,i13,i9,l00,li10,li12,li13,li9,lo0boolean_true,lo11,lo14,lo15,o11,o14,o15])])),pred,[]),b(exists([b(identifier(o15),integer,[synthesis(constant16,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)]),b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(3),integer,[])),pred,[]),b(equal(b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant16),integer,[]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(integer(1),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(integer(1),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(integer(1),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(integer(1),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o15),integer,[synthesis(constant16,output)]),b(integer(1),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(l01),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant16,i10,i12,i13,i9,l01,li10,li12,li13,li9,lo0boolean_true,lo11,lo14,lo15,o11,o14,o15])])),pred,[]),b(exists([b(identifier(o15),integer,[synthesis(constant16,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)]),b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(3),integer,[])),pred,[]),b(equal(b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant16),integer,[]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(integer(2),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(integer(2),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(integer(2),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(integer(2),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o15),integer,[synthesis(constant16,output)]),b(integer(2),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(l02),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant16,i10,i12,i13,i9,l02,li10,li12,li13,li9,lo0boolean_true,lo11,lo14,lo15,o11,o14,o15])])),pred,[]),b(exists([b(identifier(o15),integer,[synthesis(constant16,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)]),b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(3),integer,[])),pred,[]),b(equal(b(identifier(l03),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant16),integer,[]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l03),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(integer(3),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l03),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(integer(3),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l03),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(integer(3),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l03),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(integer(3),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l03),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l03),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(l03),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o15),integer,[synthesis(constant16,output)]),b(integer(3),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(l03),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant16,i10,i12,i13,i9,l03,li10,li12,li13,li9,lo0boolean_true,lo11,lo14,lo15,o11,o14,o15])])),pred,[]),b(exists([b(identifier(o15),integer,[synthesis(constant16,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)]),b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(3),integer,[])),pred,[]),b(equal(b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant16),integer,[]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o15),integer,[synthesis(constant16,output)]),b(integer(4),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(l04),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant16,i10,i12,i13,i9,l04,li10,li12,li13,li9,lo0boolean_true,lo11,lo14,lo15,o11,o14,o15])])),pred,[]),b(exists([b(identifier(o15),integer,[synthesis(constant16,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)]),b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(3),integer,[])),pred,[]),b(equal(b(identifier(l05),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant16),integer,[]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(l05),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(integer(5),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(l05),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(integer(5),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(l05),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(integer(5),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(l05),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(integer(5),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(l05),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(l05),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(l05),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o15),integer,[synthesis(constant16,output)]),b(integer(5),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(l05),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(identifier(lo0boolean_true),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant16,i10,i12,i13,i9,l05,li10,li12,li13,li9,lo0boolean_true,lo11,lo14,lo15,o11,o14,o15])])),pred,[]),b(exists([b(identifier(o15),integer,[synthesis(constant16,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)]),b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(3),integer,[])),pred,[]),b(equal(b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant16),integer,[]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o15),integer,[synthesis(constant16,output)]),b(integer(-1),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier('l0-1'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant16,i10,i12,i13,i9,'l0-1',li10,li12,li13,li9,lo0boolean_false,lo11,lo14,lo15,o11,o14,o15])])),pred,[]),b(exists([b(identifier(o15),integer,[synthesis(constant16,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)]),b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])],b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(equal(b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)]),b(integer(3),integer,[])),pred,[]),b(equal(b(identifier('l0-2'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(integer(0),integer,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(equivalence(b(greater(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(less_equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(i10),integer,[synthesis(greater1,right_input)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[]),b(conjunct(b(equivalence(b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_true,boolean,[])),pred,[])),pred,[]),b(equivalence(b(not_equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[])),pred,[])),pred,[])),pred,[])),pred,[]),b(equal(b(identifier(constant16),integer,[]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(conjunct(b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i12),integer,[synthesis(equal1,left_input)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier('l0-2'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(integer(-2),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i13),integer,[synthesis(equal1,right_input)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier('l0-2'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(integer(-2),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(i9),integer,[synthesis(greater1,left_input)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier('l0-2'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(integer(-2),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(identifier(o15),integer,[synthesis(constant16,output)])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier('l0-2'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(integer(-2),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(identifier(o14),boolean,[synthesis(equal1,output)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier('l0-2'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o11),boolean,[synthesis(greater1,output)]),b(boolean_false,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])),pred,[])),pred,[]),b(not_equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier('l0-2'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[]),b(equal(b(identifier(o14),boolean,[synthesis(equal1,output)]),b(boolean_false,boolean,[synthesis(output(0))])),pred,[])),pred,[])),pred,[]),b(implication(b(equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier('l0-2'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)])),pred,[]),b(equal(b(identifier(o15),integer,[synthesis(constant16,output)]),b(integer(-2),integer,[synthesis(input(0)),synthesis(machinevar,soda)])),pred,[])),pred,[])),pred,[]),b(not_equal(b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[]),b(not_equal(b(identifier('l0-2'),integer,[synthesis(input(0)),synthesis(machinevar,soda),synthesis(type,integer)]),b(identifier(lo0boolean_false),integer,[synthesis(output(0)),synthesis(type,boolean)])),pred,[])),pred,[])),pred,[]),b(conjunct(b(conjunct(b(conjunct(b(member(b(identifier(i10),integer,[synthesis(greater1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[]),b(member(b(identifier(i12),integer,[synthesis(equal1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i13),integer,[synthesis(equal1,right_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[]),b(member(b(identifier(i9),integer,[synthesis(greater1,left_input)]),b(interval(b(integer(-60),integer,[]),b(integer(66),integer,[])),set(integer),[])),pred,[])),pred,[])),pred,[])),pred,[used_ids([constant16,i10,i12,i13,i9,'l0-2',li10,li12,li13,li9,lo0boolean_false,lo11,lo14,lo15,o11,o14,o15])])),pred,[]),[b(identifier(li10),integer,[synthesis(greater1,right_input),synthesis(type,integer)]),b(identifier(li12),integer,[synthesis(equal1,left_input),synthesis(type,integer)]),b(identifier(li13),integer,[synthesis(equal1,right_input),synthesis(type,integer)]),b(identifier(li9),integer,[synthesis(greater1,left_input),synthesis(type,integer)]),b(identifier(lo11),integer,[synthesis(greater1,output),synthesis(type,boolean)]),b(identifier(lo14),integer,[synthesis(equal1,output),synthesis(type,boolean)]),b(identifier(lo15),integer,[synthesis(constant16,output),synthesis(type,integer)])],3,1,solution([binding(constant16,int(-1),'-1'),binding('l0-1',int(0),'0'),binding('l0-2',int(0),'0'),binding(l00,int(0),'0'),binding(l01,int(0),'0'),binding(l02,int(0),'0'),binding(l03,int(0),'0'),binding(l04,int(0),'0'),binding(l05,int(0),'0'),binding(li10,int(1),'1'),binding(li12,int(0),'0'),binding(li13,int(0),'0'),binding(li9,int(0),'0'),binding(lo0boolean_false,int(3),'3'),binding(lo0boolean_true,int(3),'3'),binding(lo11,int(3),'3'),binding(lo14,int(2),'2'),binding(lo15,int(1),'1'),binding(o15,int(-10),'-10')]),Synthesized) , 
    solve_predicate(b(equivalence(Synthesized,b(conjunct(b(greater(b(identifier(soda),integer,[]),b(integer(-1),integer,[])),pred,[]),b(greater_equal(b(identifier(coins),integer,[]),b(integer(0),integer,[])),pred,[])),pred,[])),pred,[]),_,_).

:- end_tests(synthesis).